/*!\file:  BamgMesh.h
 */ 

#ifndef _BAMGMESH_H_
#define _BAMGMESH_H_

#ifdef _SERIAL_
#include <mex.h>
#endif

class BamgMesh{

	public:

		int     VerticesSize[2];
		double* Vertices;
		int     EdgesSize[2];
		double* Edges;
		int     TrianglesSize[2];
		double* Triangles;
		int     QuadrilateralsSize[2];
		double* Quadrilaterals;
		int     VerticesOnGeometricVertexSize[2];
		double* VerticesOnGeometricVertex;
		int     VerticesOnGeometricEdgeSize[2];
		double* VerticesOnGeometricEdge;
		int     EdgesOnGeometricEdgeSize[2];
		double* EdgesOnGeometricEdge;
		int     SubDomainsSize[2];
		double* SubDomains;
		int     SubDomainsFromGeomSize[2];
		double* SubDomainsFromGeom;
		int     CrackedVerticesSize[2];
		double* CrackedVertices;
		int     CrackedEdgesSize[2];
		double* CrackedEdges;
		double* hVertices;

		/*Output for ISSM*/
		int     IssmEdgesSize[2];
		double* IssmEdges;
		int     IssmSegmentsSize[2];
		double* IssmSegments;
		int     ElementConnectivitySize[2];
		double* ElementConnectivity;
		int     NodalConnectivitySize[2];
		double* NodalConnectivity;
		int     NodalElementConnectivitySize[2];
		double* NodalElementConnectivity;

		BamgMesh();
		~BamgMesh();

		#ifdef _SERIAL_
		void GetMatlabStructureFields(mxArray* matlab_struct);
		void SetMatlabStructureFields(mxArray** matlab_struct);
		#endif

};

#endif
